> This page is for Developer.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.makeswift.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.makeswift.com/_mcp/server.

# Create Swatch

POST https://api.makeswift.com/v4/swatches
Content-Type: application/json

This feature is in beta and may change. Requests return `403` until the feature flag is enabled for your site or workspace.

Creates a site owned swatch.

Reference: https://docs.makeswift.com/developer/api-reference/rest/swatches/create-swatch

## Authentication

- `x-api-key` header (required) — API key authentication. Accepts either: - App API key (e.g. sk_eczMHVBY9fV6GYFhvs53qcnxq7yptlXL3ABKOZtn6dQ) - Site API key (UUID format, e.g. 550e8400-e29b-41d4-a716-446655440000)

## Request

### Body (application/json)

This endpoint expects a CreateSwatchV4BodyDto.

- `siteId` (string, required) — The site ID to create the swatch on.
- `hue` (double, required) — Hue value between [0, 360].
- `saturation` (double, required) — Saturation value between [0, 100].
- `lightness` (double, required) — Lightness value between [0, 100].
- `name` (string, optional, nullable) — The name of the swatch.

## Response

### 201

- `id` (string, required)
- `referenceId` (string, required) — The id to use wherever a color prop references this swatch (e.g. the "swatchId" inside backgrounds/border/boxShadow/text-color payloads) - NOT the plain "id" field above which is used in other api calls like update_swatch.
- `name` (string, required, nullable)
- `hue` (double, required)
- `saturation` (double, required)
- `lightness` (double, required)
- `siteId` (string, required)
- `pageId` (string, required, nullable) — Always `null` here. Page-owned swatches are not available through this API.

## Errors

### 400 Bad Request Error

- `object` (enum, required)
  - Allowed values: `error`
- `code` (enum, required)
  - Allowed values: `bad_request`
- `message` (string, required)

### 403 Forbidden Error

- `object` (enum, required)
  - Allowed values: `error`
- `code` (enum, required)
  - Allowed values: `forbidden`
- `message` (string, required)

### 404 Not Found Error

- `object` (enum, required)
  - Allowed values: `error`
- `code` (enum, required)
  - Allowed values: `not_found`
- `message` (string, required)

## Examples

**Request**

```json
{
  "siteId": "123e4567-e89b-12d3-a456-426614174000",
  "hue": 322,
  "saturation": 81,
  "lightness": 58
}
```

**Response**

```json
{
  "id": "8a1f3c2d-5b6e-4f7a-9c0d-1e2f3a4b5c6d",
  "referenceId": "U3dhdGNoOjhhMWYzYzJkLTViNmUtNGY3YS05YzBkLTFlMmYzYTRiNWM2ZA==",
  "name": "Brand / Pink",
  "hue": 322,
  "saturation": 81,
  "lightness": 58,
  "siteId": "123e4567-e89b-12d3-a456-426614174000",
  "pageId": "string"
}
```

**SDK Code**

```python
import requests

url = "https://api.makeswift.com/v4/swatches"

payload = {
    "siteId": "123e4567-e89b-12d3-a456-426614174000",
    "hue": 322,
    "saturation": 81,
    "lightness": 58
}
headers = {
    "x-api-key": "<apiKey>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.makeswift.com/v4/swatches';
const options = {
  method: 'POST',
  headers: {'x-api-key': '<apiKey>', 'Content-Type': 'application/json'},
  body: '{"siteId":"123e4567-e89b-12d3-a456-426614174000","hue":322,"saturation":81,"lightness":58}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.makeswift.com/v4/swatches"

	payload := strings.NewReader("{\n  \"siteId\": \"123e4567-e89b-12d3-a456-426614174000\",\n  \"hue\": 322,\n  \"saturation\": 81,\n  \"lightness\": 58\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("x-api-key", "<apiKey>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.makeswift.com/v4/swatches")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["x-api-key"] = '<apiKey>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"siteId\": \"123e4567-e89b-12d3-a456-426614174000\",\n  \"hue\": 322,\n  \"saturation\": 81,\n  \"lightness\": 58\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.makeswift.com/v4/swatches")
  .header("x-api-key", "<apiKey>")
  .header("Content-Type", "application/json")
  .body("{\n  \"siteId\": \"123e4567-e89b-12d3-a456-426614174000\",\n  \"hue\": 322,\n  \"saturation\": 81,\n  \"lightness\": 58\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.makeswift.com/v4/swatches', [
  'body' => '{
  "siteId": "123e4567-e89b-12d3-a456-426614174000",
  "hue": 322,
  "saturation": 81,
  "lightness": 58
}',
  'headers' => [
    'Content-Type' => 'application/json',
    'x-api-key' => '<apiKey>',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.makeswift.com/v4/swatches");
var request = new RestRequest(Method.POST);
request.AddHeader("x-api-key", "<apiKey>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"siteId\": \"123e4567-e89b-12d3-a456-426614174000\",\n  \"hue\": 322,\n  \"saturation\": 81,\n  \"lightness\": 58\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "x-api-key": "<apiKey>",
  "Content-Type": "application/json"
]
let parameters = [
  "siteId": "123e4567-e89b-12d3-a456-426614174000",
  "hue": 322,
  "saturation": 81,
  "lightness": 58
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.makeswift.com/v4/swatches")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```